routes/admin.php
<?php
// Emails tests
// Route::get('mailable', function () {
//     $user = App\User::find(1);
//     return new App\Mail\AdminNewUser($user);
// });
// Admin specific routes
Route::get('/', ['as' => 'root', 'uses' => 'ShowsController@index']);
Route::get('users/getdata', 'UsersController@getDataTable')->name('users.getdata');
Route::resource('users', 'UsersController');
Route::get('roles/getdata', 'RoleController@getDataTable')->name('roles.getdata');
Route::resource('roles', 'RoleController');
Route::get('permissions/getdata', 'PermissionController@getDataTable')->name('permissions.getdata');
Route::resource('permissions', 'PermissionController');
Route::resource('roles', 'RoleController');
// Shows
Route::get('shows/getdata', 'ShowsController@getDataTable')->name('shows.getdata');
Route::resource('shows', 'ShowsController');
// Residents
Route::get('residents/getdata', 'ResidentsController@getDataTable')->name('residents.getdata');
Route::resource('residents', 'ResidentsController');
//settings
Route::resource('settings', 'SettingsController');
// Taxonomies
Route::get('taxonomies/getdata', 'TaxonomiesController@getDataTable')->name('taxonomies.getdata');
Route::resource('taxonomies', 'TaxonomiesController', ['except' => ['create']]);
Route::get('taxonomies/create/{parent_id}', 'TaxonomiesController@create')->name('taxonomies.create');
Route::post('taxonomies/reorder/{id}', 'TaxonomiesController@reorder')->name('taxonomies.reorder');
Route::post('{table_type}/reorder', 'AdminController@orderObject')->name('reorder');
// Medias
Route::get('medias/getdata', 'MediasController@getDataTable')->name('medias.getdata');
Route::delete('medias/quickdestroy', 'MediasController@quickDestroy')->name('medias.quickdestroy');
Route::resource('medias', 'MediasController');
Route::get('mediasArticle/{model_type}/{model_id}/{collection_name}', 'MediasController@mediasArticle')->name('medias.article');
Route::post('medias/storeandlink/{mediatable_type}/{article_id?}', 'MediasController@storeAndLink')->name('medias.storeandlink');
Route::post('medias/reorder/{model_type}/{article_id}/{collection_name}', 'MediasController@reorder')->name('medias.reorder');
// Route::post('medias/get', 'MediasController@getFromArray');
Route::post('medias/ajaxUpdate/{mediatable_type}', 'MediasController@AjaxUpdate')->name('medias.ajaxupdate');
Route::post('fileupload', 'MediasController@fileUpload')->name('fileupload');
// Events
Route::get('events/{parent_id}/getdata', 'EventsController@getDataTable')->name('events.getdata');
Route::resource('events', 'EventsController', ['except' => ['create', 'index']]);
Route::get('events/{parent_id}/create', 'EventsController@create')->name('events.create');
Route::get('events/{parent_id?}/index', 'EventsController@index')->name('events.index');
Route::post('events/reorder/{id}', 'EventsController@reorder')->name('events.reorder');
// Articles
Route::get('articles/getdata', 'ArticlesController@getDataTable')->name('articles.getdata');
Route::resource('articles', 'ArticlesController');
// Videos
Route::get('videos/{parent_id}/getdata', 'VideosController@getDataTable')->name('videos.getdata');
Route::resource('videos', 'VideosController', ['except' => ['create', 'index']]);
Route::get('videos/{parent_id}/create', 'VideosController@create')->name('videos.create');
Route::get('videos/{parent_id?}/index', 'VideosController@index')->name('videos.index');
Route::post('videos/reorder/{id}', 'VideosController@reorder')->name('videos.reorder');
// Banners
Route::get('banners/getdata', 'BannersController@getDataTable')->name('banners.getdata');
Route::resource('banners', 'BannersController');
// Pages
Route::get('pages/{parent_id}/getdata', 'PagesController@getDataTable')->name('pages.getdata');
Route::resource('pages', 'PagesController', ['except' => ['create', 'index']]);
Route::get('pages/{parent_id}/create', 'PagesController@create')->name('pages.create');
Route::get('pages/{parent_id?}/index', 'PagesController@index')->name('pages.index');
Route::post('pages/reorder/{id}', 'PagesController@reorder')->name('pages.reorder');
// Datatables
Route::get('datatable', 'DataTablesController@datatable');
Route::get('datatable/getArticles', 'DataTablesController@getArticles')->name('datatable/getdata');

routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Auth
Auth::routes();

// Language switcher
Route::get('lang/{language}', ['as' => 'lang.switch', 'uses' => 'LocaleController@switch']);
// Homepage
Route::get('/', 'HomeController@index')->name('homepage');
// Pages index
Route::get('/pages/{article_slug}', 'PagesController@show')->name('pages.show');
Route::get('/about', 'PagesController@about')->name('pages.about');

// Article
Route::get('/interviews', 'ArticlesController@index')->name('articles.index');
Route::get('/interviews/{slug}', 'ArticlesController@show')->name('articles.show');
// Residents
Route::get('/residents', 'ResidentsController@index')->defaults('category', 'the-word')->name('residents.index');
Route::get('/residents/category/{slug}', 'ResidentsController@index')->name('residents.indexbycategory');
Route::get('/residents/{slug}', 'ResidentsController@show')->name('residents.show');
// Shows
Route::get('/shows', 'ShowsController@index')->name('shows.index');
Route::get('/shows/tag/{slug}', 'ShowsController@indexByTag')->name('shows.indexbytags');
Route::get('/residents/{resident_slug}/shows/{slug}', 'ShowsController@show')->name('shows.show');
// Events
Route::get('/agenda', 'EventsController@index')->name('events.index');
Route::get('/agenda/{slug}', 'EventsController@show')->name('events.show');
Route::get('/agenda/single/{slug}', 'EventsController@showSingle')->name('events.single.show');
// Videos
Route::get('/videos/category/{slug}/{parent?}', 'VideosController@index')->name('videos.index');
Route::get('/videos/{slug}', 'VideosController@show')->name('videos.show');
// Search
Route::get('/search', 'HomeController@index')->name('search');
// Tags
Route::get('/tags/{slug}', 'HomeController@index')->name('tags');
// Schedule
Route::get('/schedule', 'HomeController@schedule')->name('schedule');
// Search
Route::get('/search', 'SearchController@search')->name('search');

// Redirects V1
Route::redirect('/series/{resident_slug}/shows/{slug}', '/residents/{resident_slug}/shows/{slug}');
Route::redirect('/series/{resident_slug}', '/residents/{resident_slug}');

resources/views/admin/templates/articles-index.blade.php
@extends('admin.app')

@section('page_title', $data['page_title'])
@section('page_class', $data['page_class'])

@section('content')
<div class="panel panel-default">
  <div class="table-responsive">
    @include('admin.components.datatable-loading')
    <a href="{{ route('admin.articles.create') }}" class="btn btn-primary btn-xs">{{__('admin.add')}}</a>
    <table class="panel-body table table-hover table-bordered table-striped table-reorderable" id="datatable" style="width:100%">
      <?php // TODO: THEAD caché, à afficher selon les besoins + ajouter flèches si tri par colonne ?>
        <thead class="hidden">
          <tr>
            <th class="is-published"></th>
            <th class="main-column">Title</th>
            <th class="hidden-small">Updated</th>
            <th></th>
          </tr>
        </thead>
    </table>
  </div>
</div>
@endsection

@section('meta')
<meta name="csrf-token" content="{{ csrf_token() }}" />
@endsection

@section('scripts')
<script src="https://cdn.datatables.net/1.10.12/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/rowreorder/1.2.3/js/dataTables.rowReorder.min.js"></script>
<script type="text/javascript">
$(document).ready(function() {
    var table = $('#datatable').DataTable({
      responsive: true,
      autoWidth: false,
      processing: true,
      serverSide: true,
      iDisplayLength: 50,
      rowReorder: {
          selector: '.reorder'
      },
      colReorder: false,
      stateSave: true,
      dom       : '<"panel-heading"f> <"panel-body"t> <"panel-footer"<li>p>',
      initComplete: function(settings, json) {
          $('div.datatable-loading').hide();
        },
      ajax: '{{ route('admin.' .$data['table_type']. '.getdata') }}',
      language: {
        'search': '',
        'searchPlaceholder': '{{ $data['page_title'] }}',
        'paginate': {
          'previous': '&larr;',
          'next': '&rarr;'
        },
        'lengthMenu': "{{__('admin.datatable_lengthMenu')}}",
        'zeroRecords': "{{__('admin.datatable_zeroRecords')}}",
        'info': "{{__('admin.datatable_info')}}",
      },
      columns: [
        {data: 'order', render: function ( data, type, row, meta ) {
          var cl = 'fa icon-published';
          cl += (row.featured == 1) ? ' featured' : '' ;

          if(row.published == 1){
            cl += ' fa-circle';
          }else {
            cl += ' fa-circle-o';
          }
          return '<i class="' + cl + '" title="{{__('admin.not_published')}}"></i>';
        }, name: 'order', searchable: false, orderable: false, class: 'is-published'},
        {data: 'title_link', render: function ( data, type, row, meta ) {
          return data;
        }, name: 'title', orderable: false, class: 'main-column'},
        {data: 'updated_at', render: function ( data, type, row, meta ) {
          return '<div class="text-content">'+ data + '</div>';
        }, name: 'updated_at', searchable: false, orderable: false, class: 'hidden-small updated_at'},
        {data: 'action', render: function ( data, type, row, meta ) {
          return data + '<i class="fa fa-sort reorder"></i>';
        }, name: 'action', orderable: false, searchable: false, class:'faded'}
      ]
    });

    table.on( 'row-reorder', function ( e, diff, edit ) {
      var articlesArray = [];
      for ( var i=0, ien=diff.length ; i<ien ; i++ ) {
        var rowData = table.row( diff[i].node ).data();
        var newOrder = diff[i].newPosition;
        articlesArray.push({
          id: rowData.id,
          position: newOrder
        });
      }
      var jsonString = JSON.stringify(articlesArray);
      $.ajax({
        url     : '{{ route('admin.reorder', ['table_type' => $data['table_type']]) }}',
        type    : 'POST',
        data    : jsonString,
        dataType: 'json',
        success : function ( json ) {
          $('#datatable').DataTable().ajax.reload(); // refresh datatable
            // $.each(json, function (key, msg) {
        	  // // handle json response
            // });
        }
      });
    });
    $.fn.dataTable.ext.errMode = 'throw';
});
</script>
@endsection

resources/views/admin/templates/events-index.blade.php
<?php
  if(!empty($parent_article)):
    $parent_id = $parent_article->id;
    $page_title = $parent_article->title;
    $bt_add_label = __('admin.add_subpage');
  else:
    $parent_id = 0;
    $page_title = $data['page_title'];
    $bt_add_label = __('admin.add');
  endif;
?>

@extends('admin.app')
@section('page_title', $data['page_title'])
@section('page_class', $data['page_class'])

@section('content')
  <div class="panel panel-default">
    @if($parent_id > 0)
      <a href="{{ route('admin.' .$data['table_type']. '.index', 0) }}" class="link link__back">← Events</a>
    @endif
    <div class="table-responsive">
      @include('admin.components.datatable-loading')
      <a href="{{ route('admin.events.create', $parent_id) }}" class="btn btn-primary btn-xs">{{ $bt_add_label }}</a>
      <table class="panel-body table table-hover table-bordered table-striped table-reorderable" id="datatable" style="width:100%">
          <thead class="hidden">
            <tr>
              <th class="is-published"></th>
              <th class="main-column">Title</th>
              <th class="hidden-small"></th>
              <th></th>
            </tr>
          </thead>
      </table>
    </div>
  </div>

@endsection

@section('meta')
  <meta name="csrf-token" content="{{ csrf_token() }}" />
@endsection

@section('scripts')
<script src="https://cdn.datatables.net/1.10.12/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/rowreorder/1.2.3/js/dataTables.rowReorder.min.js"></script>
<script type="text/javascript">
function format ( parent ) {
  // `d` is the original data object for the row
  var request = '{{ route('admin.' .$data['table_type']. '.getdata', ':id') }}';
  request = request.replace(':id', parent.id);
  var h;
  $.ajaxSetup({async:false});
  $.get(request, function(data) {
    var data = data.data;
    if (data.length > 0) {
      h = '<table>';
      for(var i = 0; i < data.length; i++) {
        h += '<tr>';
        if(data[i].published == 1){
          h += '<td class="is-published"><i class="fa fa-circle icon-published"  title="{{__('admin.published')}}"></i></td>';
        }else {
          h += '<td class="is-published"><i class="fa fa-circle-o icon-published"  title="{{__('admin.not_published')}}"></i></td>';
        }
        h += '<td class="main-column"><div class="text-content">'+ data[i].title +'</div></td>';
        var edit = '{{ route('admin.events.edit', ':id') }}';
        edit = edit.replace(':id', data[i].id);
        h += '<td><a href="'+ edit +'" class="link"> {{__('admin.edit')}}</a></td>';
        h += '</td>';
      }
      h += '</table>';
    }
  });
  $.ajaxSetup({async:true});
  return h;
}

$(document).ready(function() {
    var table = $('#datatable').DataTable({
      responsive: true,
      autoWidth: false,
      processing: true,
      serverSide: true,
      iDisplayLength: 50,
      stateSave: true,
      rowReorder: {
          selector: '.reorder'
      },
      colReorder: false,
      dom       : '<"panel-heading"f> <"panel-body"t> <"panel-footer"<li>p>',
      initComplete: function(settings, json) {
          $('.datatable-loading').hide();
        },
      ajax: '{{ route('admin.' .$data['table_type']. '.getdata', $parent_id) }}',
      language: {
        "search": '',
        'searchPlaceholder': '{{ $page_title }}',
        "paginate": {
          "previous": '&larr;',
          "next": '&rarr;'
        },
        lengthMenu: "{{__('admin.datatable_lengthMenu')}}",
        zeroRecords: "{{__('admin.datatable_zeroRecords')}}",
        info: "{{__('admin.datatable_info')}}",
      },
      columns: [
        {data: 'order', render: function ( data, type, row, meta ) {
          var cl = 'fa icon-published';
          cl += (row.featured == 1) ? ' featured' : '' ;

          if(row.published == 1){
            cl += ' fa-circle';
          }else {
            cl += ' fa-circle-o';
          }
          return '<i class="' + cl + '" title="{{__('admin.not_published')}}"></i>';
        }, name: 'order', searchable: false, orderable: false, class: 'is-published'},
        {data: 'title', render: function ( data, type, row, meta ) {
          return '<div class="text-content">'+ data + '</div>';
        }, name: 'title', orderable: false, class: 'main-column'},
        {data: 'dates', render: function ( data, type, row, meta ) {
          return '<div class="text-content">'+ data + '</div>';
        }, name: 'dates', searchable: false, orderable: false, class: 'hidden-small'},
        {data: 'action', render: function ( data, type, row, meta ) {
          return data + '<i class="fa fa-sort reorder"></i>';
        }, name: 'action', orderable: false, searchable: false, class:'faded'}
      ]
    });

    table.on( 'row-reorder', function ( e, diff, edit ) {
      var articlesArray = [];
      for ( var i=0, ien=diff.length ; i<ien ; i++ ) {
        var rowData = table.row( diff[i].node ).data();
        var newOrder = diff[i].newPosition;
        articlesArray.push({
          id: rowData.id,
          position: newOrder
        });
      }
      var jsonString = JSON.stringify(articlesArray);
      $.ajax({
        url     : '{{ route('admin.reorder', ['table_type' => $data['table_type']]) }}',
        type    : 'POST',
        data    : jsonString,
        dataType: 'json',
        success : function ( json ) {
          $('#datatable').DataTable().ajax.reload(); // refresh datatable
            $.each(json, function (key, msg) {
        	  // handle json response
          });
        }
      });
    });
    $.fn.dataTable.ext.errMode = 'throw';

    // Add event listener for opening and closing details
    $('#datatable tbody').on('click', '.has-child .main-column', function () {
        var tr = $(this).closest('tr');
        var row = table.row(tr);
        if ( row.child.isShown() ) {
            // This row is already open - close it
            row.child.hide();
            tr.removeClass('shown');
        }
        else {
            // Open this row
            row.child( format(row.data()) ).show();
            tr.addClass('shown');
            tr.next().addClass('datatable-child');
        }
    } );
});
</script>
@endsection

resources/views/admin/templates/medias-index.blade.php
@extends('admin.app')

@section('page_title', $data['page_title'])
@section('page_class', $data['page_class'])

@section('content')
<div class="panel panel-default">
  <div class="table-responsive">
    @include('admin.components.datatable-loading')
    {{-- <a href="{{ route('admin.medias.create') }}" class="btn btn-primary btn-xs">{{__('admin.add')}}</a> --}}
    <table class="table table-hover table-bordered table-striped" id="datatable" style="width:100%">
        <thead class="hidden">
          <tr>
            <th class="media-preview"></th>
            <th class="main-column">Name</th>
            <th class="hidden-small">Dimensions</th>
            <th></th>
          </tr>
        </thead>
    </table>
  </div>
</div>
@endsection

@section('meta')
<meta name="csrf-token" content="{{ csrf_token() }}" />
@endsection

@section('scripts')
<script src="https://cdn.datatables.net/1.10.12/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/rowreorder/1.2.3/js/dataTables.rowReorder.min.js"></script>
<script type="text/javascript">
$(document).ready(function() {
    var table = $('#datatable').DataTable({
      responsive: true,
      autoWidth: false,
      processing: true,
      serverSide: true,
      rowReorder: false,
      colReorder: false,
      iDisplayLength: 50,
      stateSave: true,
      dom       : '<"panel-heading"f> <"panel-body panel-body--medias"t> <"panel-footer"<li>p>',
      initComplete: function(settings, json) {
          $('.datatable-loading').hide();
        },
      ajax: '{{ route('admin.' .$data['table_type']. '.getdata') }}',
      language: {
        "search": '',
        'searchPlaceholder': '{{ $data['page_title'] }}',
        "paginate": {
          "previous": '&larr;',
          "next": '&rarr;'
        },
        lengthMenu: "{{__('admin.datatable_lengthMenu')}}",
        zeroRecords: "{{__('admin.datatable_zeroRecords')}}",
        info: "{{__('admin.datatable_info')}}",
      },
      columns: [
        {data: 'img', render: function ( data, type, row, meta ) {
          if(row.mime_type.includes("image", 0)){
            return '<img src="'+ data +'">';
          }else if(row.mime_type.includes("pdf", 0)){
            return '<div><span>PDF</span></div>';
          }else if(row.mime_type.includes("video", 0)){
            return '<div><span>VIDEO</span></div>';
          }else{
            return '<div><span>FILE</span></div>';
          }
        }, class: 'media-preview'},
        {data: 'name', render: function ( data, type, row, meta ) {
          return '<div class="text-content">'+ data + '</div>';
        }, name: 'name', orderable: false, class: 'main-column'},
        {data: 'custom_properties', render: function ( data, type, row, meta ) { if(row.width){return row.width +' &times; '+ row.height}else{return null}}, name: 'custom_properties', orderable: false, class: 'hidden-small'},
        {data: 'action', name: 'action', orderable: false, searchable: false, class:'faded'}
      ]
    });

    table.on( 'row-reorder', function ( e, diff, edit ) {
      var articlesArray = [];
      for ( var i=0, ien=diff.length ; i<ien ; i++ ) {

        var rowData = table.row( diff[i].node ).data();
        var newOrder = diff[i].newPosition;
        articlesArray.push({
          id: rowData.id,
          position: newOrder
        });
      }
      var jsonString = JSON.stringify(articlesArray);
      $.ajax({
        url     : '{{ route('admin.reorder', ['table_type' => $data['table_type']]) }}',
        type    : 'POST',
        data    : jsonString,
        dataType: 'json',
        success : function ( json ) {
          $('#datatable').DataTable().ajax.reload(); // refresh datatable
            $.each(json, function (key, msg) {
        	  // handle json response
          });
        }
      });
    });
    $.fn.dataTable.ext.errMode = 'throw';

});
</script>
@endsection

resources/views/admin/templates/page-edit.blade.php
@extends('admin.app')

@section('page_title', $data['page_title'])
@section('page_class', $data['page_class'])

@section('content')
    @if(isset($article->id))
      <div class="edit__header">
        <h1 class="edit__title">Edit</h1>
      </div>
      {!! Form::model($article, ['route' => ['admin.pages.update', $article->id], 'method' => 'put', 'class' => 'panel panel-edit main-form', 'id' => 'main-form', 'files' => true]) !!}
    @else
      <div class="edit__header">
        <h1 class="edit__title">Create</h1>
      </div>
      {!! Form::model($article, ['route' => ['admin.pages.store'], 'method' => 'post', 'class' => 'panel panel-edit main-form', 'id' => 'main-form', 'files' => true]) !!}
    @endif
        <div id="validation"></div>
        @include('admin.components.page-form', ['submitButtonText' => 'Save'])
        {!! Form::close() !!}
        <aside class="article-aside">
          @include('admin.components.media-aside')
        </aside>
        @if(isset($article->id))
          <ul class="panel-footer">
            <li>@include('admin.components.delete-form', ['model' => $article, 'model_name' => 'pages'])</li>
            <li><a href="{{ url('/') }}/{{ $article->slug }}" class="link" target="_blank">{{ __('admin.preview') }}</a> {{ __('admin.on_website') }}</li>
          </ul>
        @endif
    @endsection
@section('meta')
  <meta name="csrf-token" content="{{ csrf_token() }}" />
@endsection

resources/views/admin/templates/pages-index.blade.php
<?php
  if(!empty($parent_article)):
    $parent_id = $parent_article->id;
    $page_title = $parent_article->title;
    $bt_add_label = __('admin.add_subpage');
  else:
    $parent_id = 0;
    $page_title = $data['page_title'];
    $bt_add_label = __('admin.add');
  endif;
?>

@extends('admin.app')

@section('page_title', $data['page_title'])
@section('page_class', $data['page_class'])

@section('content')
  <div class="panel panel-default">
    @if($parent_id > 0)
      <a href="{{ route('admin.' .$data['table_type']. '.index', 0) }}" class="link link__back">← Pages</a>
    @endif
    <div class="table-responsive">
      @include('admin.components.datatable-loading')
      <a href="{{ route('admin.pages.create', $parent_id) }}" class="btn btn-primary btn-xs">{{ $bt_add_label }}</a>
      <table class="panel-body table table-hover table-bordered table-striped table-reorderable" id="datatable" style="width:100%">
          <thead class="hidden">
            <tr>
              <th class="is-published"></th>
              <th class="main-column">Title</th>
              <th class="hidden-small"></th>
              <th></th>
            </tr>
          </thead>
      </table>
    </div>
  </div>

@endsection

@section('meta')
  <meta name="csrf-token" content="{{ csrf_token() }}" />
@endsection

@section('scripts')
<script src="https://cdn.datatables.net/1.10.12/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/rowreorder/1.2.3/js/dataTables.rowReorder.min.js"></script>
<script type="text/javascript">
function format ( parent ) {
  // `d` is the original data object for the row
  var request = '{{ route('admin.' .$data['table_type']. '.getdata', ':id') }}';
  request = request.replace(':id', parent.id);
  var h;
  $.ajaxSetup({async:false});
  $.get(request, function(data) {
    var data = data.data;
    if (data.length > 0) {
      h = '<table>';
      for(var i = 0; i < data.length; i++) {
        h += '<tr>';
        if(data[i].published == 1){
          h += '<td class="is-published"><i class="fa fa-circle icon-published"  title="{{__('admin.published')}}"></i></td>';
        }else {
          h += '<td class="is-published"><i class="fa fa-circle-o icon-published"  title="{{__('admin.not_published')}}"></i></td>';
        }
        h += '<td class="main-column"><div class="text-content">'+ data[i].title +'</div></td>';
        var edit = '{{ route('admin.pages.edit', ':id') }}';
        edit = edit.replace(':id', data[i].id);
        h += '<td><a href="'+ edit +'" class="link"> {{__('admin.edit')}}</a></td>';
        h += '</td>';
      }
      h += '</table>';
    }
  });
  $.ajaxSetup({async:true});
  return h;
}

$(document).ready(function() {
    var table = $('#datatable').DataTable({
      responsive: true,
      autoWidth: false,
      processing: true,
      serverSide: true,
      iDisplayLength: 50,
      stateSave: true,
      rowReorder: {
          selector: '.reorder'
      },
      colReorder: false,
      dom       : '<"panel-heading"f> <"panel-body"t> <"panel-footer"<li>p>',
      initComplete: function(settings, json) {
          $('.datatable-loading').hide();
        },
      ajax: '{{ route('admin.' .$data['table_type']. '.getdata', $parent_id) }}',
      language: {
        "search": '',
        'searchPlaceholder': '{{ $page_title }}',
        "paginate": {
          "previous": '&larr;',
          "next": '&rarr;'
        },
        lengthMenu: "{{__('admin.datatable_lengthMenu')}}",
        zeroRecords: "{{__('admin.datatable_zeroRecords')}}",
        info: "{{__('admin.datatable_info')}}",
      },
      columns: [
        {data: 'order', render: function ( data, type, row, meta ) {
          if(row.published == 1){
            return '<i class="fa fa-circle icon-published" title="{{__('admin.published')}}"></i>';
          }else {
            return '<i class="fa fa-circle-o icon-published" title="{{__('admin.not_published')}}"></i>';
          }
        }, name: 'order', searchable: false, class: 'is-published'},
        {data: 'title', render: function ( data, type, row, meta ) {
          return '<div class="text-content">'+ data + '</div>';
        }, name: 'title', orderable: false, class: 'main-column'},
        {data: 'updated_at', render: function ( data, type, row, meta ) {
          return '<div class="text-content">'+ data + '</div>';
        }, name: 'updated_at', searchable: false, orderable: false, class: 'hidden-small updated_at'},
        {data: 'action', render: function ( data, type, row, meta ) {
          return data + '<i class="fa fa-sort reorder"></i>';
        }, name: 'action', orderable: false, searchable: false, class:'faded'}
      ]
    });

    table.on( 'row-reorder', function ( e, diff, edit ) {
      var articlesArray = [];
      for ( var i=0, ien=diff.length ; i<ien ; i++ ) {
        var rowData = table.row( diff[i].node ).data();
        var newOrder = diff[i].newPosition;
        articlesArray.push({
          id: rowData.id,
          position: newOrder
        });
      }
      var jsonString = JSON.stringify(articlesArray);
      $.ajax({
        url     : '{{ route('admin.reorder', ['table_type' => $data['table_type']]) }}',
        type    : 'POST',
        data    : jsonString,
        dataType: 'json',
        success : function ( json ) {
          $('#datatable').DataTable().ajax.reload(); // refresh datatable
            $.each(json, function (key, msg) {
        	  // handle json response
          });
        }
      });
    });
    $.fn.dataTable.ext.errMode = 'throw';

    // Add event listener for opening and closing details
    $('#datatable tbody').on('click', '.has-child .main-column', function () {
        var tr = $(this).closest('tr');
        var row = table.row(tr);
        if ( row.child.isShown() ) {
            // This row is already open - close it
            row.child.hide();
            tr.removeClass('shown');
        }
        else {
            // Open this row
            row.child( format(row.data()) ).show();
            tr.addClass('shown');
            tr.next().addClass('datatable-child');
        }
    } );
});
</script>
@endsection